﻿Class Window1

    Private categoriaDados As New NorthwindDataSet
    Private taCat As New NorthwindDataSetTableAdapters.CategoriesTableAdapter
    Private taManager As New NorthwindDataSetTableAdapters.TableAdapterManager
    Private view As CollectionView

    Private Sub Window1_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        Me.taCat.Fill(Me.categoriaDados.Categories)
        Me.DataContext = Me.categoriaDados.Categories
        Me.taManager.CategoriesTableAdapter = taCat

        Me.view = CollectionViewSource.GetDefaultView(Me.categoriaDados.Categories)

    End Sub

    Private Sub btnPrimeiro_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnPrimeiro.Click
        Me.view.MoveCurrentToFirst()
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnAnterior.Click
        If view.CurrentPosition > 0 Then
            Me.view.MoveCurrentToPrevious()
        End If
    End Sub

    Private Sub btnProximo_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnProximo.Click
        If Me.view.CurrentPosition < Me.view.Count - 1 Then
            Me.view.MoveCurrentToNext()
        End If
    End Sub

    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnUltimo.Click
        Me.view.MoveCurrentToLast()
    End Sub

    Private Sub btnExcluir_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnExcluir.Click
        If Me.view.CurrentPosition > -1 Then
            If MessageBox.Show("Você deseja excluir estas informaçôes ? ", Me.Title, MessageBoxButton.YesNo) = MessageBoxResult.Yes Then
                Dim linha = CType(Me.view.CurrentItem, System.Data.DataRowView).Row
                linha.Delete()
                MsgBox("Os dados foram excluídos.")
            End If
        End If
    End Sub

    Private Sub btnNovo_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnNovo.Click
        Dim linha = Me.categoriaDados.Categories.NewCategoriesRow
        linha.CategoryName = "[Novo]"
        Me.categoriaDados.Categories.AddCategoriesRow(linha)
        Me.view.MoveCurrentToLast()
    End Sub

    Private Sub btnCancelar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnCancelar.Click
        If Me.categoriaDados.HasChanges Then
            If MessageBox.Show("Você deseja cancelar as alterações feitas ? ", Me.Title, MessageBoxButton.YesNo) = MessageBoxResult.Yes Then
                Me.categoriaDados.RejectChanges()
            End If
        End If
    End Sub

    Private Sub btnSalvar_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnSalvar.Click
        Try
            If Me.categoriaDados.HasChanges Then
                If Me.taManager.UpdateAll(Me.categoriaDados) > 0 Then
                    MsgBox("Dados salvos com sucesso !")
                End If
            End If
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub
End Class
